# Update a shift

PATCH https://api.letsdeel.com/rest/v2/time_tracking/shifts/{external_id}
Content-Type: application/json

Update specific fields of an existing shift by its unique `external_id`. This includes shift summary details, description etc.
 **Token scopes**: `time-tracking:write`

Reference: https://developer.deel.com/api/endpoints/time-tracking-shifts/update-time-tracking-shift-by-external-id

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /time_tracking/shifts/{external_id}:
    patch:
      operationId: update-time-tracking-shift-by-external-id
      summary: Update a shift
      description: >-
        Update specific fields of an existing shift by its unique `external_id`.
        This includes shift summary details, description etc.
         **Token scopes**: `time-tracking:write`
      tags:
        - subpackage_timeTrackingShifts
      parameters:
        - name: external_id
          in: path
          description: Unique identifier of the shift to be updated.
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Shift updated successfully.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/time-tracking-shifts_updateTimeTrackingShiftByExternalId_Response_200
        '400':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                data:
                  $ref: >-
                    #/components/schemas/TimeTrackingShiftsExternalIdPatchRequestBodyContentApplicationJsonSchemaData
                  description: Shift update request data.
              required:
                - data
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    TimeTrackingShiftsExternalIdPatchRequestBodyContentApplicationJsonSchemaDataSummaryTimeUnit:
      type: string
      enum:
        - HOUR
        - DAY
        - WEEK
        - MONTH
      description: Time unit
      title: >-
        TimeTrackingShiftsExternalIdPatchRequestBodyContentApplicationJsonSchemaDataSummaryTimeUnit
    TimeTrackingShiftsExternalIdPatchRequestBodyContentApplicationJsonSchemaDataSummary:
      type: object
      properties:
        time_unit:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsExternalIdPatchRequestBodyContentApplicationJsonSchemaDataSummaryTimeUnit
          description: Time unit
        time_amount:
          type: number
          format: double
          description: Time amount
        total_break_hours:
          type: number
          format: double
          description: Total break hours
        payable_break_hours:
          type: number
          format: double
          description: Payable break hours
        total_payable_hours:
          type: number
          format: double
          description: Total payable hours
        shift_duration_hours:
          type: number
          format: double
          description: Shift duration hours
        shift_rate_external_id:
          type: string
          description: Shift Rate external ID
      description: Summary of calculated time and rates for the shift.
      title: >-
        TimeTrackingShiftsExternalIdPatchRequestBodyContentApplicationJsonSchemaDataSummary
    TimeTrackingShiftsExternalIdPatchRequestBodyContentApplicationJsonSchemaDataPayrollCycleRef:
      type: object
      properties:
        date:
          type: string
          description: Date in ISO 8601 format that helps referencing a payroll cycle
      required:
        - date
      description: Reference to the payroll cycle associated with this shift.
      title: >-
        TimeTrackingShiftsExternalIdPatchRequestBodyContentApplicationJsonSchemaDataPayrollCycleRef
    TimeTrackingShiftsExternalIdPatchRequestBodyContentApplicationJsonSchemaData:
      type: object
      properties:
        summary:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsExternalIdPatchRequestBodyContentApplicationJsonSchemaDataSummary
          description: Summary of calculated time and rates for the shift.
        description:
          type: string
          description: Description of the shift.
        date_of_work:
          type: string
          description: The date of the shift.
        payroll_cycle_ref:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsExternalIdPatchRequestBodyContentApplicationJsonSchemaDataPayrollCycleRef
          description: Reference to the payroll cycle associated with this shift.
      description: Shift update request data.
      title: >-
        TimeTrackingShiftsExternalIdPatchRequestBodyContentApplicationJsonSchemaData
    TimeTrackingShiftsExternalIdPatchResponsesContentApplicationJsonSchemaDataSummaryTimeUnit:
      type: string
      enum:
        - HOUR
        - DAY
        - WEEK
        - MONTH
      description: Time unit
      title: >-
        TimeTrackingShiftsExternalIdPatchResponsesContentApplicationJsonSchemaDataSummaryTimeUnit
    TimeTrackingShiftsExternalIdPatchResponsesContentApplicationJsonSchemaDataSummary:
      type: object
      properties:
        time_unit:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsExternalIdPatchResponsesContentApplicationJsonSchemaDataSummaryTimeUnit
          description: Time unit
        time_amount:
          type: number
          format: double
          description: Time amount
        total_break_hours:
          type: number
          format: double
          description: Total break hours.
        payable_break_hours:
          type: number
          format: double
          description: Payable break hours.
        total_payable_hours:
          type: number
          format: double
          description: Total payable hours.
        shift_duration_hours:
          type: number
          format: double
          description: Shift duration hours.
        shift_rate_external_id:
          type: string
          description: ShiftRate external ID.
      description: Summary of calculated time and rates for the shift.
      title: >-
        TimeTrackingShiftsExternalIdPatchResponsesContentApplicationJsonSchemaDataSummary
    TimeTrackingShiftsExternalIdPatchResponsesContentApplicationJsonSchemaDataPayrollCycleRef:
      type: object
      properties:
        date:
          type: string
          description: Date in ISO 8601 format that helps referencing a payroll cycle
      required:
        - date
      description: Reference to the payroll cycle associated with this shift.
      title: >-
        TimeTrackingShiftsExternalIdPatchResponsesContentApplicationJsonSchemaDataPayrollCycleRef
    TimeTrackingShiftsExternalIdPatchResponsesContentApplicationJsonSchemaData:
      type: object
      properties:
        summary:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsExternalIdPatchResponsesContentApplicationJsonSchemaDataSummary
          description: Summary of calculated time and rates for the shift.
        created_at:
          type: string
          description: Timestamp when the shift was created.
        updated_at:
          type: string
          description: Timestamp when the shift was last updated.
        contract_id:
          type: string
          description: The contract ID associated with the shift.
        description:
          type: string
          description: The description of the shift.
        external_id:
          type: string
          description: Unique identifier of the shift.
        date_of_work:
          type: string
          description: The date of the shift.
        payroll_cycle_ref:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsExternalIdPatchResponsesContentApplicationJsonSchemaDataPayrollCycleRef
          description: Reference to the payroll cycle associated with this shift.
      description: Updated shift record details.
      title: >-
        TimeTrackingShiftsExternalIdPatchResponsesContentApplicationJsonSchemaData
    time-tracking-shifts_updateTimeTrackingShiftByExternalId_Response_200:
      type: object
      properties:
        data:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsExternalIdPatchResponsesContentApplicationJsonSchemaData
          description: Updated shift record details.
      title: time-tracking-shifts_updateTimeTrackingShiftByExternalId_Response_200
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/time_tracking/shifts/12345678g"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/time_tracking/shifts/12345678g';
const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/time_tracking/shifts/12345678g"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/time_tracking/shifts/12345678g")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://api.letsdeel.com/rest/v2/time_tracking/shifts/12345678g")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://api.letsdeel.com/rest/v2/time_tracking/shifts/12345678g', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/time_tracking/shifts/12345678g");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/time_tracking/shifts/12345678g")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```